View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0010752CMakeCMakepublic2010-05-24 16:482016-06-10 14:31
ReporterDaniel Levin 
Assigned ToBrad King 
PrioritynormalSeverityminorReproducibilityalways
StatusclosedResolutionmoved 
PlatformOSOS Version
Product VersionCMake-2-8 
Target VersionFixed in Version 
Summary0010752: Detect and warn about conflicting output paths
DescriptionPassing CMAKE_BINARY_DIR as RUNTIME_OUTPUT_DIRECTORY for the subtarget results in invalid link.txt file for this subtarget with output path as "." (dot):

...
# in root directory:
add_subdirectory( "b" )

...
# in subdirectory:
add_executable( b main.cpp )
set_target_properties( b PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}" )

...
$ cat b/CMakeFiles/b.dir/link.txt
/usr/bin/c++ CMakeFiles/b.dir/main.o -o . -rdynamic
TagsNo tags attached.
Attached Fileszip file icon a.zip [^] (838 bytes) 2010-05-24 16:48

- Relationships Relation Graph ] Dependency Graph ]

-  Notes
(0020839)
Brad King (manager)
2010-05-27 09:58

You're asking CMake to create an executable file in ${CMAKE_BINARY_DIR} with the same name ("b") as a directory (also "b"). This cannot possibly be represented on disk with traditional filesystems. If I change the name of the executable to "b2" then it works.
(0020847)
Daniel Levin (reporter)
2010-05-27 17:20

That is true. Maybe CMake should handle such kind of mistakes and inform user with readable message? The error at build time is far from obvious.
(0020854)
Brad King (manager)
2010-05-28 08:33

I'm updating the summary of this bug to reflect the real change needed.

We need to record the set of output paths known to be generated in the build tree along with the context that causes each to be added. When more than one context adds the same output path then we can warn (or error?).
(0022029)
David Cole (manager)
2010-08-31 15:31

We will not be addressing this for the upcoming CMake 2.8.3 release.
(0030527)
Brad King (manager)
2012-08-13 10:37

Sending issues I'm not actively working on to the backlog to await someone with time for them.

If an issue you care about is sent to the backlog when you feel it should have been addressed in a different manner, please bring it up on the CMake mailing list for discussion. Sign up for the mailing list here, if you're not already on it:

 http://www.cmake.org/mailman/listinfo/cmake [^]

It's easy to re-activate a bug here if you can find a CMake developer or contributor who has the bandwidth to take it on.
(0041704)
Kitware Robot (administrator)
2016-06-10 14:28

Resolving issue as `moved`.

This issue tracker is no longer used. Further discussion of this issue may take place in the current CMake Issues page linked in the banner at the top of this page.

- Issue History
Date Modified Username Field Change
2010-05-24 16:48 Daniel Levin New Issue
2010-05-24 16:48 Daniel Levin File Added: a.zip
2010-05-24 17:40 Bill Hoffman Status new => assigned
2010-05-24 17:40 Bill Hoffman Assigned To => Brad King
2010-05-27 09:58 Brad King Note Added: 0020839
2010-05-27 17:20 Daniel Levin Note Added: 0020847
2010-05-28 08:33 Brad King Note Added: 0020854
2010-05-28 08:33 Brad King Summary Invalid output path to binary in link.txt => Detect and warn about conflicting output paths
2010-08-31 15:31 David Cole Note Added: 0022029
2012-08-13 10:37 Brad King Status assigned => backlog
2012-08-13 10:37 Brad King Note Added: 0030527
2016-06-10 14:28 Kitware Robot Note Added: 0041704
2016-06-10 14:28 Kitware Robot Status backlog => resolved
2016-06-10 14:28 Kitware Robot Resolution open => moved
2016-06-10 14:31 Kitware Robot Status resolved => closed


Copyright © 2000 - 2017 MantisBT Team
Powered by Mantis Bugtracker